<?php
/**
*
* Plugin to display a single Database entry in a normal content article
*
* @package		JooDatabase - http://joodb.feenders.de
* @copyright	Copyright (C) Computer - Daten - Netze : Feenders. All rights reserved.
* @license		GNU/GPL, see LICENSE
* @author		Dirk Hoeschen (hoeschen@feenders.de)
* @version 	1.7
*
**/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgContentJoodb extends JPlugin {
	
	protected $_joobase = null;
	protected $_data = null;
	protected $_db = null;
	
	/**
	 * Constructor
	 *
	 * @access      protected
	 * @param       object  $subject The object to observe
	 * @param       array   $config  An array that holds the plugin configuration
	 * @since       1.5
	 */
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$t = $this->loadLanguage("com_joodb",JPATH_BASE);	
	}
	
	
	/**
	 * Plugin for backward compatibility to 1.5
	 * @param	mixed	An object with a "text" property or the string to be cloaked.
	 * @param	array	Additional parameters.
	 * @param	int		Optional page number. Unused. Defaults to zero.
	 * @return	boolean	True on success.
	 */
	public function onPrepareContent( &$row, &$params, $limitstart=0 ) {
		$plugin =& JPluginHelper::getPlugin('content', 'joodb');
		$this->params = new JParameter( $plugin->params );
		return $this->_getJoodbContent($row, $params);
	}

	/**
	 * Plugin that replaces {joodb XX} with a single view of the dataset with ID #XX
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	mixed	An object with a "text" property or the string to be cloaked.
	 * @param	array	Additional parameters.
	 * @param	int		Optional page number. Unused. Defaults to zero.
	 * @return	boolean	True on success.
	 */
	public function onContentPrepare($context, &$row, &$params, $limitstart=0 ) {
		return $this->_getJoodbContent($row, $params);
	}

	/**
	 * Parse article content and replace finds ...
	 * 
	 * @param object $row
	 * @param object $params
	 */	
	protected function _getJoodbContent(&$row, &$params ) {
		// find tags in content-text
		preg_match_all('/\{joodbitem (.*?)\}/iU',$row->text, $matches);
		if ($matches) {			
			// add joodb style
			$document = &JFactory::getDocument();
			$document->addStyleSheet(JURI::root(true)."/components/com_joodb/assets/joodb.css");
							
			$this->_db = &JFactory::getDbo();
			/**
			 * todo: rather primitive check for pro version 
			 */
			if (!file_exists(JPATH_SITE.'/components/com_joodb/helpers/subtemplate.php')) return false;
			require_once(JPATH_SITE.'/components/com_joodb/models/article.php');
			require_once(JPATH_SITE.'/components/com_joodb/helpers/joodb.php');
			require_once(JPATH_SITE.'/components/com_joodb/helpers/subtemplate.php');
			$document = &JFactory::getDocument();
			$document->addStyleSheet(JURI::root(true)."/components/com_joodb/assets/joodb.css");
			JHTML::_('behavior.modal');
			JTable::addIncludePath(JPATH_SITE.'/administrator/components/com_joodb/tables');
			$this->_joobase = &JTable::getInstance( 'joodb', 'Table' );
			$this->_getJoobase($this->params->get('joobase',1));
			
			if (empty($params)) {
				$application = JFactory::getApplication();
				$params	= &$application->getParams();				
				$params = & $this->params;
			}
			$params->merge(JComponentHelper::getParams('com_joodb'));			
		
			$params->set('link_titles',false);
			$params->set('link_urls',false);
			
			foreach($matches[1] as $match) {
				// parameter 2 use joodb x
				$p = preg_split("/,/", $match);
				if (count($p)>=2) {
					$id = (int) $p[0];
					$this->_getJoobase((int) $p[1]);
				} else {
					$id = (int) $match;
				}
				
				$parts = JoodbHelper::splitTemplate($this->_joobase->tpl_single);
				// remove backbutton e.g.
				foreach ($parts as &$p) 
					if ($p->function=="backbutton") 
						$p->function="";
				
				if ($this->_getData($id)) {
					$output =  JoodbHelper::parseTemplate($this->_joobase, $parts,$this->_data);
				} else $output = JText::sprintf('ENTRY_NOT_FOUND',$id); 	
				$row->text = preg_replace("/\{joodbitem ".$match."\}/i",'<div class="database-article">'.$output.'</div>', $row->text);
			}
		}		
		return true;
	}
	

	/**
	 * Method to get Data from table in Database
	 *
	 * @access protectes
	 * @return boolean true or false
	 */
	protected function _getData($id)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$statequery = ($this->_joobase->fstate) ? " AND `".$this->_joobase->fstate."`=1 " : " ";
			$db = & $this->_joobase->getTableDBO();
			/* Query single object. */
			$db->setQuery("SELECT * FROM `".$this->_joobase->table
							."` WHERE `".$this->_joobase->fid."`='".(int)$id."'".$statequery." LIMIT 1;");
			$this->_data = $db->loadObject();
			echo $db->getErrorMsg();
		}
		return (empty($this->_data)) ? false : true;
	}	

	/**
	 * Prepare Joodatabase
	 *
	 * @access protectes
	 * @return boolean true or false
	 */
	protected function _getJoobase($id)
	{
		if (empty($this->joobase->id) || $this->joobase->id!=$id) { 
			$this->_joobase->load($id);
			// get the table field list
			$this->_joobase->fields = $this->_db->getTableFields($this->_joobase->table);
			$this->_joobase->fields = $this->_joobase->fields[$this->_joobase->table];
		}	
		return ($this->_joobase) ? false : true;
	}
	
}
